/*
 *  Revision 20180306, Kai Peter
 *  - moved all 'setsockopt' functions to socket_options.c
 *  Revision 20180131, Kai Peter
 *  - changed to 'ipv4socket' (thanks Erwin Hoffmann)
 *  - code clean-up, switched to 'errmsg.h'
 *  Revision 20160728; Kai Peter
 *  - consolidated 'socket_bind6.c' into 'socket_bind.c' (from ucspi-tcp-0.88)
*/

#include "socket.h"
#include "byte.h"
#include "ip.h"
#include "errmsg.h"
/*
int socket_bind4(int s,const char ip[4],uint16 port) {
  struct sockaddr_in sa;

  byte_zero(&sa,sizeof(sa));
  sa.sin_family = AF_INET;
  uint16_pack_big((char *)&sa.sin_port,port);
  byte_copy((char *)&sa.sin_addr,4,ip);

  return bind(s,(struct sockaddr *)&sa,sizeof(sa));
}
*/
//int socket_bind6(int s, const char ip[16], uint16 port, uint32 scope_id) {
int socket_bind(int s, const char ip[16], uint16 port, uint32 scope_id) {
  struct sockaddr_in6 sa;

  if (ipv4socket) {    //  { return socket_bind4(s,ip+12,port); }
    struct sockaddr_in sa;

	byte_zero(&sa,sizeof(sa));
	sa.sin_family = AF_INET;
	uint16_pack_big((char *)&sa.sin_port,port);
	byte_copy((char *)&sa.sin_addr,4,ip);

	return bind(s,(struct sockaddr *)&sa,sizeof(sa));
  }

  byte_zero(&sa,sizeof(sa));
  sa.sin6_family = AF_INET6;
  uint16_pack_big((char *) &sa.sin6_port,port);
/*  implicit: sa.sin6_flowinfo = 0; */
  byte_copy((char *)&sa.sin6_addr,16,ip);
  sa.sin6_scope_id = scope_id;

  return bind(s,(struct sockaddr *) &sa,sizeof(sa));
}

/* set socket option to reuse a binded socket */
int socket_reuse(int s) {
  int opt = 1;
  return setsockopt(s,SOL_SOCKET,SO_REUSEADDR,&opt,sizeof(opt));
}
