/* taken from ucspi-tcp-0.88: mconnect-io.c
 *
 *  Revision 20170718, Kai Peter
 *  - switched: strerr --> errmsg
 *  Revision 20160628, Kai Peter
 *  - replaced "fork.h", "readwrite.h", "exit.h" with <unistd.h>
*/
#include <unistd.h>
#include "sig.h"
#include "wait.h"
#include "buffer.h"
#include "errmsg.h"
#include "fmt.h"

#define WHO "qtcpconn-io"

char outbuf[512];
buffer bout;

char inbuf[512];
buffer bin;

ssize_t myread(int fd,char *buf,int len)
{
  buffer_flush(&bout);
  return read(fd,buf,len);
}

/* prevent warning implicit function declaration */
void kill(int pid,int sig_term);

int main()
{
  int pid;
  int wstat;
  char ch;

  sig_ignore(sig_pipe);
  pid = fork();       /* gets the pid of the second process */

  if (pid == -1) err_mem;

  if (!pid) {   /* this first process has pid 0 (real 'pid - 1') */
    buffer_init(&bin,myread,0,inbuf,sizeof inbuf);
    buffer_init(&bout,write,7,outbuf,sizeof outbuf);  //fd 7: write to network

    while (buffer_get(&bin,&ch,1) == 1) {
      if (ch == '\n') buffer_put(&bout,"\r",1);
      buffer_put(&bout,&ch,1);
    }
    _exit(0);
  }

  buffer_init(&bin,myread,6,inbuf,sizeof inbuf);     //fd 6: read from network
  buffer_init(&bout,write,1,outbuf,sizeof outbuf);

  // receive
  while (buffer_get(&bin,&ch,1) == 1) {		/* higher pid */
    buffer_put(&bout,&ch,1);
  }

  kill(pid,sig_term);
  wait_pid(&wstat,pid);
  _exit(0);
}
